# -*- coding: utf-8 -*-
"""Task-4.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1bunpY7N-E0TV_6FdlLj_dL7QBJRpqjW0
"""

import os

import cv2
import matplotlib.pyplot as plt
import seaborn as sns
import numpy as np

import tensorflow as tf
import keras.backend as K
from tensorflow import keras

os.environ['KMP_DUPLICATE_LIB_OK']='True'

os.environ["SM_FRAMEWORK"] = "tf.keras"

import albumentations as A
import segmentation_models as sm
sm.set_framework('tf.keras')

sm.framework()

from keras.metrics import MeanIoU
import keras.backend as K
from sklearn.model_selection import train_test_split

from google.colab import drive
drive.mount('/content/drive')
drive_path = '/content/drive/MyDrive/task_4'

train_direction = f'{drive_path}/cropped_img_256/'
mask_direction = f'{drive_path}/cropped_mask_256/'

INPUT_SIZE = (256,256,3)

train = sorted(os.listdir(train_direction))
mask = sorted(os.listdir(mask_direction))

out_rgb = []
out_mask = []

counter_empty = 0

for p_img, p_mask in zip(train, mask):   
    img_path = os.path.join(train_direction, p_img)
    mask_path = os.path.join(mask_direction, p_mask)
    
    img = cv2.cvtColor(cv2.imread(img_path), cv2.COLOR_BGR2RGB) / 255.
    mask = cv2.imread(mask_path)
    
    mask = mask[:, :, :1]
    mask[mask > 0.] = 1.
    
    if 1 not in mask: counter_empty+=1
    
    if not(1 not in mask and counter_empty >= 40):
        out_rgb += [img]
        out_mask += [mask]

out_rgb = np.array(out_rgb).astype('float32')
out_mask = np.array(out_mask).astype('float32')

shuffle=True
test_size=0.20

X_train, X_test, y_train, y_test = train_test_split(out_rgb, out_mask,\
                                                    test_size=test_size,\
                                                    shuffle=shuffle)

from albumentations import Compose, OneOf, RandomSizedCrop, PadIfNeeded
from albumentations import VerticalFlip, RandomRotate90, ElasticTransform
from albumentations import GridDistortion, OpticalDistortion

random_sized_crop = RandomSizedCrop(min_max_height=(50, 101), height=256,\
                                    width=256, p=0.5)
pad_if_needed = PadIfNeeded(min_height=256, min_width=256, p=0.5)

vertical_flip = VerticalFlip(p=0.5)

andom_rotate_90 = RandomRotate90(p=0.5)

elastic_transform = ElasticTransform(p=0.5, alpha=120, sigma=120 * 0.05,\
                                     alpha_affine=120 * 0.03)
grid_distortion = GridDistortion(p=0.5)
optical_distortion = OpticalDistortion(distort_limit=1, shift_limit=0.5, p=1)

aug = Compose([
    OneOf([random_sized_crop, pad_if_needed],p=1),
    vertical_flip,
    andom_rotate_90,
    OneOf([elastic_transform, grid_distortion, optical_distortion, ], p=0.8)])

def make_image_gen(X_train, y_train, aug, batch_size):

    X_row = X_train.shape[0]

    while True:

        idxs = np.random.permutation(X_row)
        batch_x = []
        batch_y = []
        for i in idxs:

            x = X_train[i]
            y = y_train[i]
            augmented = aug(image=x, mask=y)
            x_aug = augmented['image']
            y_aug = augmented['mask']
            batch_x.append(x_aug)
            batch_y.append(y_aug)
            if len(batch_x) == batch_size:

                yield np.array(batch_x, dtype='float32'),\
                 np.array(batch_y, dtype='float32')
                batch_x = []
                batch_y = []


batch_size = 32
train_gen = make_image_gen(X_train, y_train, aug, batch_size)
aug_x, aug_y = next(train_gen)

from tensorflow import reshape, exp, reduce_mean
from keras.losses import binary_crossentropy
import tensorflow as tf

def focal_loss(targets, inputs, alpha=0.2, gamma=2):
    
    inputs = reshape(inputs, [-1])
    targets = reshape(targets, [-1])
    
    BCE = binary_crossentropy(targets, inputs)
    BCE_EXP = exp(-BCE)
    focal_loss = reduce_mean(alpha * tf.pow((1 - BCE_EXP), gamma) * BCE)
    
    return focal_loss

from segmentation_models import Unet

model = Unet('efficientnetb0', classes=1, input_shape=INPUT_SIZE,\
                activation='sigmoid', encoder_weights='imagenet')

model.compile(optimizer='Adam', loss=focal_loss, metrics = [MeanIoU(num_classes=2)])

from keras.callbacks import EarlyStopping, ModelCheckpoint

model_checkpoint = ModelCheckpoint(monitor = 'val_loss',\
                                   filepath='keras_model_model_checkpoint.h5',\
                                   verbose = 3, save_best_only = True,\
                                   mode = 'min')

early_stopping = EarlyStopping(monitor="val_loss", mode="min")

val_data = (X_test, y_test)

generator = make_image_gen(X_train, y_train, aug, 16)
epochs=50
steps_per_epoch = 200
callbacks = [model_checkpoint, early_stopping]

model.fit_generator(generator=generator, epochs=epochs, steps_per_epoch = steps_per_epoch,\
                    callbacks = callbacks, validation_data = val_data)

predictions = model.predict(X_test)

for img, pred, g_truth in zip(X_test[:20], predictions[5:20], y_test[5:20]):
  
  fig, ax = plt.subplots(1, 3, figsize=(10, 7))
  ax[0].imshow(img)
  ax[0].axis('off')
  ax[0].set_title("Image")
  sns.heatmap(pred, cmap='gray', ax=ax[1], xticklabels=False, yticklabels=False,\
              cbar=False)
  
  ax[1].axis('off')
  ax[1].set_title("Prediction")
  sns.heatmap(g_truth, cmap='gray', ax=ax[2], xticklabels=False, yticklabels=False,\
              cbar=False)
  
  ax[2].axis('off')
  ax[2].set_title("Actual")

model.save('keras_model.h5')

